package Ptrs;

public class Name
{ int nref=0;
  String title; // this is merely for convenience. It's not part of the machine proper
  Xmits snds=new Xmits(), rcvs=new Xmits(); 
  Xmits snds_dormant=new Xmits(), rcvs_dormant=new Xmits();
  Name fusion=null; // fusions go from lesser-id to greater-id
  int id=0;

  static int count=0;
  public Name() {id=count; count++;}

  public String toString()
  { String s=title; if (fusion!=null) s=s+"="+fusion.title;
    s=s+Integer.toString(nref);
    s=s+"["; boolean f=true;
    for (int i=0; i<snds.size(); i++) {if (!f) {s=s+",";f=false;} s=s+"o*";}     
    for (int i=0; i<rcvs.size(); i++) {if (!f) {s=s+",";f=false;} s=s+"i*";}     
    for (int i=0; i<snds_dormant.size(); i++) {if (!f) {s=s+",";f=false;} s=s+"o.";}     
    for (int i=0; i<rcvs_dormant.size(); i++) {if (!f) {s=s+",";f=false;} s=s+"i.";}     
    s=s+"]";
    return s;
  }

  // fuseto - fuse the current name to a dest
  // the dest will have its nref incremented
  public void fuseto(Name dst) throws Exception
  { if (dst.id<id) throw new Exception("fuseto message sent to the wrong guy");
    else if (fusion==null) {fusion=dst; dst.nref++; return;}
    else if (dst.id<fusion.id)
    { Name oldf=fusion; oldf.nref--; fusion=null;
      fusion=dst; dst.nref++; dst.fuseto(oldf);
    }
    else if (dst.id>fusion.id)
    { fusion.fuseto(dst);
    }
    else throw new Exception("fuseto message encountered dodgy equals");
  }
}

class Names extends java.util.Vector
{ public final synchronized Name nameAt(int i)
  { return (Name)elementAt(i);
  }
}