package TextModel;

public class Operators extends Model.Operators
{

  public Model.State Nil()
  { State s=new State(); s.sb=""; return s;
  }

  public Model.State Fus(String a,String b)
  { State s=new State(); s.sb=a+"="+b; return s;
  }

  public Model.State Par(Model.State as1,Model.State as2) throws Exception
  { State ms1=(State)as1, ms2=(State)as2;
    String s1=ms1.Collapse(true,false), s2=ms2.Collapse(true,false); 
    State ms=new State(); ms.sb=s1+" | "+s2; ms.ispar=true;
    return ms;
  }

  public Model.State Res(String[] rs,Model.State ssa)
  { State s=(State)ssa;
    for (int i=rs.length-1; i>=0; i--) s.res.insertElementAt(rs[i],0);
    // nb. each restrictions must be added *OUTSIDE*!
    return s;
  }

  public Model.State Rep(Model.State ss) 
  { State s=(State)ss;
    s.sb = s.Collapse(false,false); s.ispar=false; s.issum=false;
    s.sb="!"+s.sb;
    return s;
  }

  public Model.State Sum(Model.State as1,Model.State as2)
  { State ms1=(State)as1, ms2=(State)as2;
    State s = new State();
    s.sb = ms1.Collapse(false,true)+" + "+ms2.Collapse(false,true);
    return s;
  }

  public Model.State Snd(String n,String[] dat,boolean isbound,Model.State P) {return Xmit(true,n,dat,isbound,(State)P);}
  public Model.State Rcv(String n,String[] dat,boolean isbound,Model.State P) {return Xmit(false,n,dat,isbound,(State)P);}
  public Model.State Xmit(boolean issend,String n,String[] dat,boolean isbound,State P)
  { String x=n;
    if (dat.length==0)
    { if (issend) x+="!"; else x+="?";
    }
    else
    { String head="", tail="";
      if (issend && !isbound) {head="<"; tail=">";}
      else if (issend && isbound) {head="!("; tail=")";}
      else if (!issend && !isbound) {head="?"; tail="";}
      else if (!issend && isbound) {head="("; tail=")";}
      x += head;
      for (int i=0; i<dat.length; i++) {if (i!=0) x+=","; x+=dat[i];}
      x += tail;
    }
    String ps = P.Collapse(false,false);
    if (ps!="0" && ps!="nil") x+="."+ps;
    //
    State s=new State(""); s.sb=x;
    return s;
  }

}
